; Wybierak do Stolca
;
; game entry for
; FORTIFICATION ATARI PARTY 2013
;
; created by: mgr inz. Rafal
;

		opt h+l+

pstart	equ $e00-$22-$3ff-$1

		org pstart

player		equ $3433			; --> $3bf4
music		equ $2ce9			; --> $3432
screen		equ $2400+$400		; --> $2ce8
dl_game		equ screen-$400
font_game	equ	$2000
c_excreme1	equ 62
c_excreme2	equ 63
c_obsta1	equ 15+3*64
c_obsta2	equ 11+3*64
spr_PMBASE	equ dl_game		; DL must fit into $180 bytes
sprites_beg	equ spr_PMBASE+$180
sprites_end	equ spr_PMBASE+$3ff+1
pmg_wybier	equ	spr_PMBASE+$200
pmg_enemyL	equ	spr_PMBASE+$280
pmg_enemyR	equ	spr_PMBASE+$300
pmg_pusherL	equ spr_PMBASE+$380
pmg_pusherR	equ spr_PMBASE+$180
shit_begin	equ $19
shit_maxpos	equ $3d-8
wyb_init_y	equ $2d
wyb_max_y	equ $52
excrem_init	equ $35
excrem_dlii	equ 13+1
blink_delay	equ 10
shitco_init	equ	1	; Initial shit cover
wyb_base_of	equ	$5c	; Offset of the top of base
delay_t		equ	10	; Delay
wyb_init_x	equ $ff/2-4
wyb_y_st_o	equ	25	; Initial y-offset of the wybierak
enemy_min_y	equ $2f	; Minimum Y-position of the enemy
enemy_max_y	equ $42 ; Maximum Y-position of the enemy
wyb_ani_spd	equ 10	; Wybierak animation speed
pusher_y	equ $5a	; Y-position of pusher
psh_ani_spd	equ 7	; Animation speed of pusher legs

; Keys
key_ESC				equ	$1c

; Colors
col_wybierak_head	equ $9c
col_wybierak_body	equ $85
col_pusherL			equ $bc
col_pusherR			equ $c8
col_excrements		equ $16
col_asses1			equ	$3a
col_asses2			equ	$fa
col_footer1			equ $03
col_footer2			equ $af
col_statustext		equ $00
col_main_title0		equ $9f
col_main_title1		equ $9f-4
col_main_title2		equ $9f-8
col_main_title3		equ $9f-12
col_szlaczek		equ $97
col_obstacle		equ $b7

; Variables
tmp01		equ $80
assbp		equ $81		; stores the address of the top row of the asses
scrol		equ $83		; ass scroll offset
assbp_mid	equ $84		; stores the address of the middle row of the asses
assbp_low	equ $86		; stores the address of the bottom row of the asses
tmp_addr0	equ $88
tmp_addr1	equ $90
excrement	equ $92		; stores the address of the excrement row
excre_rand	equ	$94		; Stores c_excreme1 or c_excreme2 in order to spawn random excrements
enemy_x1	equ	$95		; Horizontal position of the right part of the enemy
drift_spd	equ $96		; Current spontaneous ass drift speed
						;		bit7 = direction
						;		bit0 = fast
enemy_x		equ $97		; Horizontal position of the enemy
enemy_dir	equ	$98		; Enemy direction (0 = left, 1 = right)
shittrail	equ $99		; Offset of the shit trail in DLI
wybierak_y	equ	$9a		; Vertical position of the wybierak
dli_excrem	equ	$9b		; Here we switch color of wybierak to excrement in DLI (VCOUNT)
dl_excreml	equ	$9c		; Here we switch color of wybierak to excrement in DLI (DL offset)
dli_exc_up	equ $9d
shit_cover	equ	$9e		; Shit coverage counter
obsta_rand	equ	$9f		; Stores c_obsta1 or c_obsta2 in order to spawn random obstacles
wybierak_x	equ $a0
enemy_delay	equ $a1
enemy_y		equ $a2		; Y-position of the enemy
wybierak_fr	equ	$a3		; Number of wybierak frame being displayed (0->1->2->3--<)
wyb_fr_advc	equ	$a4		; Wybierak frame advance counter
tmp02		equ $a5
hours		equ $a6		; Playtime: hours
minutes		equ $a7		; Playtime: minutes
seconds		equ $a8		; Playtime: seconds
framecnt	equ	$a9		; Frame counter
shitmax		equ	$aa		; Max shit coverage counter
pusherL_X	equ	$ab		; X-position of the left pusher
pusher_fram	equ $ac		; Current pusher frame (0->1->2--<)
psh_fr_advc	equ	$ad		; Pusher legs advance counter
pusherR_X0	equ	$ae		; X-position of the right pusher
pusherR_X1	equ	$af		; ditto
pusherR_X2	equ	$b0		; ditto
pusherR_X3	equ	$b1		; ditto
oldvbiaddr	equ	$b2		; Old VBI vector
inmenu		equ	$b4		; 1 = in menu, 0 = in game
asses_initd	equ	$b5		; 1 = asses already initialized
polish		equ	$b6		; 1 = polish language
bot_hscrol	equ $b7		; HSCROL for bottom text on the menu page
bot_offset	equ	$b8		; Current offset of the bottom text
firereadel	equ	$b9		; Fire reaction delay
blink_clear	equ	$ba		; bit0=1 = blink_clear, bit0=0 = blink_show
blink_cnt	equ $bb		; Blink delay counter
_NEXT_		equ $bc

; System
GPRIOR	equ	$26f
SDMCTL	equ $22f
SDLSTL	equ	$230
RTCLOK	equ $12
HSCROL	equ $d404
RANDOM	equ $d20a
STICK0	equ	$278
STICK1	equ	$279
STRIG0	equ	$284
CHARSET	equ $e000
CHBAS	equ $2f4
GRAFP0	equ	$d00d
HPOSP0	equ	$d000
HPOSP1	equ $d001
HPOSP2	equ	$d002
HPOSP3	equ	$d003
HPOSM0	equ $d004
HPOSM1	equ $d005
HPOSM2	equ $d006
HPOSM3	equ $d007
COLPM0	equ $d012
COLPM2	equ $d014
WSYNC	equ $d40a
VCOUNT	equ	$d40b
NMIEN	equ $d40e
VDSLST	equ $200
COLBK	equ $d01a
COLPF0	equ $d016
COLPF1	equ $d017
COLPF2	equ $d018
COLPF3	equ $d019
COLOR0	equ $2c4
COLOR1	equ $2c5
COLOR2	equ $2c6
COLOR3	equ $2c7
COLOR4	equ $2c8
PCOLR1	equ $2c1
PCOLR2	equ $2c2
PCOLR3	equ $2c3
ATRACT	equ $4d
GRACTL	equ $d01d
PMBASE	equ $d407
DMACTL	equ $d400
SIZEP0	equ $d008
SIZEP1	equ $d009
SIZEP2	equ $d00a
SIZEP3	equ $d00b
SIZEM	equ	$d00c
PCOLR0	equ $2c0
PORTB	equ $d301
BASICF	equ	$3f8
HITCLR	equ	$d01e
P0PF	equ $d004
P0PL	equ	$d00c
SETVBV	equ $e45c
XITVBV	equ $e462
CH		equ	$2fc
HELPFG	equ $2dc

		lda #0
		sta polish

begin	
		lda #25
		sta firereadel
		jsr pre_game_screen_clean

		lda #0
		sta asses_initd
		
		sta bot_offset
		lda #7
		sta bot_hscrol

		jsr music_init
		jsr chars_init
backtm	jsr engine_init
		ldy asses_initd
		cpy #1
		beq main0
		lda #1
		sta asses_initd
		jsr ass_chain_init
		jsr excrement_chain_init
main0	jsr screen_init
		jsr hide_sprites
		lda #1
		sta inmenu
		jsr play_kanikuly
		jsr draw_title_page0
		jsr draw_title

		lda #$ff
		sta CH

		jmp main_menu_loop

winner_row_0
		dta d"okres krycia stolcem"

winner
		jsr write_shit_cover
		jsr play_winner
		jsr pre_winner_screen_clean
		jsr switch_to_winner_screen
		jsr copy_status_bars

		lda polish
		cmp #1
		beq winner3

		ldy #0
winner2	lda winner_row_0_en,y
		sta screen+396,y
		iny
		cpy #20
		bne winner2
		jmp winner1

winner3	ldy #0
winner0	lda winner_row_0,y
		sta screen+396,y
		iny
		cpy #20
		bne winner0

winner1	jsr write_winning_time

winner_loop
		jsr synchro

		jsr blink_percent_indicator
		jsr spontaneous_ass_drift
		jsr delay
		lda STRIG0
		sta ATRACT
		cmp #0
		bne winner_loop
		jmp begin

draw_bottom_scroll
		ldy bot_hscrol
		dey
		sty bot_hscrol

		cpy #$ff
		bne drbots1
		ldx bot_offset
		inx
		cpx #92+50+9+50+17+4
		bne drbots2
		ldx #0
drbots2	stx bot_offset
		ldx #7
		stx bot_hscrol

drbots1	ldy bot_offset
		ldx #0
drbots	lda title_mgr,y
		sta screen+616,x
		iny
		inx
		cpx #22
		bne drbots
		rts

draw_title
		jsr draw_bottom_scroll

		ldy #0
		ldx #0
dratiX	lda #72
		sta screen+116+40,y
		iny
		lda #74
		sta screen+116+40,y
		iny
		inx
		cpx #20
		bne dratiX

		ldy #0
		lda #49+64
drati2	sta screen+596,y
		iny
		clc
		adc #64
		cmp #49+64*2
		bne drati3
		clc
		adc #64
drati3	cpy #20
		bne drati2

		ldy #0
		lda polish
		cmp #1
		beq drati0a


drati0	lda title_string_en,y
		sta screen+96,y
		iny
		cpy #20
		bne drati0

		ldy #0
drati1	lda subtitle_string_en,y
		sta screen+116,y
		iny
		cpy #40
		bne drati1

		jmp drati5

drati0a lda title_string,y
		sta screen+96,y
		iny
		cpy #20
		bne drati0a

		ldy #0
drati1a	lda subtitle_string,y
		sta screen+116,y
		iny
		cpy #40
		bne drati1a

drati5	ldy #0
		lda #76+128
drati4	sta screen+236,y
		sta screen+236+40*6,y
		iny
		eor #%10000000
		cpy #40
		bne drati4
		lda #76
		sta screen+236+40*1
		sta screen+236+40*3
		sta screen+236+40*5
		sta screen+236+40*2+39
		sta screen+236+40*4+39
		eor #%10000000
		sta screen+236+40*2
		sta screen+236+40*4
		sta screen+236+40*1+39
		sta screen+236+40*3+39
		sta screen+236+40*5+39

		ldy #0
drati6	lda version_string,y
		sta screen+236+40*7,y
		iny
		cpy #4
		bne drati6

		rts

main_menu_loop
		jsr synchro

		ldy firereadel
		dey
		cpy #$ff
		bne mamelo1
		ldy #0
mamelo1	sty firereadel

		jsr draw_bottom_scroll

		lda HELPFG
		cmp #17
		bne mamelo0
		
		lda polish
		eor #%00000001
		sta polish

		lda #0
		sta HELPFG

		jsr draw_title
		jsr draw_title_page0

mamelo0	jsr delay
		jsr spontaneous_ass_drift

		lda firereadel
		cmp #0
		bne main_menu_loop
		lda STRIG0
		sta ATRACT
		cmp #0
		bne main_menu_loop

		; Switch to game DL
		jsr pre_game_screen_clean
		jsr game_init
		jsr play_mortal
		jsr switch_to_game_screen
		jmp main_loop

pre_winner_screen_clean
		; Clear screen memory
		ldx <screen+96
		ldy >screen+96
		stx tmp_addr0
		sty tmp_addr0+1

		ldy #0
swtgs1	lda #0
		sta (tmp_addr0),y
		clc
		lda tmp_addr0
		adc #<1
		sta tmp_addr0
		lda tmp_addr0+1
		adc #>1
		sta tmp_addr0+1
		ldx tmp_addr0
		cpx #<(screen+1156)
		bne swtgs1
		ldx tmp_addr0+1
		cpx #>(screen+1156)
		bne swtgs1
		rts

pre_game_screen_clean
		; Clear screen memory
		ldx <screen+96
		ldy >screen+96
		stx tmp_addr0
		sty tmp_addr0+1

		ldy #0
swtgs0	lda #0
		sta (tmp_addr0),y
		clc
		lda tmp_addr0
		adc #<1
		sta tmp_addr0
		lda tmp_addr0+1
		adc #>1
		sta tmp_addr0+1
		ldx tmp_addr0
		cpx #<(screen+1256)
		bne swtgs0
		ldx tmp_addr0+1
		cpx #>(screen+1256)
		bne swtgs0
		rts

title_string
		dta d" WYBIERAK DO STOLCA "*
title_string_en
		dta d"INVASION FROM EXCREX"*
title_mgr
		dta d"                    "
		dta d"  16K compatible game entry for FORTIFICATION 2013 "
		dta d"atari"*
		dta d" PARTY written by MGR INZ. RAFA"
		dta b(53)
		dta d"      greetings to all "*
		dta d"8-BIT"
		dta d" freaks from all over the world      "*
		dta d"credits go to ADAM "
		dta b(c_obsta1),b(c_obsta2)
		dta d" ODYNIEC1 "
		dta b(c_obsta2),b(c_obsta1)
		dta d" SEBAN "
		dta b(c_obsta1),b(c_obsta2)
		dta d" VIDOL "
		dta d"                       "
subtitle_string
		dta d"czyli  Niesko"*
		dta b(69+128)
		dta d"czony "*
		dta b(53+128)
		dta d"a"*
		dta b(69+128)
		dta d"cuch Ludzkich Dup"*
subtitle_string_en
		dta d"     aka  Last Days of Planet Earth     "*

switch_to_game_screen
		; DL setup
		ldx <dl_game
		ldy >dl_game
		stx SDLSTL
		sty SDLSTL+1
		rts

switch_to_winner_screen
		jsr hide_sprites
		; DL setup
		ldx <dl_winner
		ldy >dl_winner
		stx SDLSTL
		sty SDLSTL+1
		rts

game_init
		jsr time_init
		jsr status_init
		jsr coverage_init
		jsr hide_sprites
		jsr sprites_init
		jsr wybierak_init
		jsr variables_init
		rts

randomize_enemy_direction
		lda RANDOM
		sec
		sbc #128
		bcc raendi0
		lda enemy_dir
		eor #%00000001
		sta enemy_dir
raendi0	rts

pusherL_legs2_data
		dta b($30),b($30),b($28),b($28)

initialize_enemy_position_and_direction
		lda RANDOM
		sta enemy_delay
		lda RANDOM
		sec
		sbc #128
		bcc inepad1
		lda #0
		sta enemy_dir
		lda #$fe
		sta enemy_x1
		sta HPOSP2
		lda #$fe-8
		sta enemy_x
		sta HPOSP1
		jmp inepad0
inepad1	lda #1
		sta enemy_dir
		lda #0
		sta enemy_x
		sta HPOSP1
		lda #0+8
		sta enemy_x1
		sta HPOSP2
inepad0	rts

screen_for_coverage_init
		ldy <screen+1231
		ldx >screen+1231
		sty tmp_addr0
		stx tmp_addr0+1
		rts		

status_init
		ldy <screen+1216
		ldx >screen+1216
		sty tmp_addr0
		stx tmp_addr0+1

		ldy #0

		lda polish
		cmp #1
		beq stain0a
		
sta_in0	lda time_string,y
		sta (tmp_addr0),y
		iny
		cpy #13
		bne sta_in0

		jsr screen_for_coverage_init
		ldy #0
sta_in1	lda shit_string,y
		sta (tmp_addr0),y
		iny
		cpy #25
		bne sta_in1

		jsr write_time

		ldy #$ff
sta_in2	iny
		jsr finishing_coverage
		bne sta_in2
		rts

stain0a	lda time_string_pl,y
		sta (tmp_addr0),y
		iny
		cpy #13
		bne stain0a

		jsr screen_for_coverage_init
		
		ldy #0
stain1a	lda shit_string_pl,y
		sta (tmp_addr0),y
		iny
		cpy #25
		bne stain1a

		jsr write_time

		ldy #$ff
stain2a	iny
		jsr finishing_coverage
		bne stain2a

		rts

finishing_coverage
		lda #81
		sta screen+1156,y
		iny
		lda #113
		sta screen+1156,y
		cpy #39
		rts

title_page1_0
		dta d"Wielkie dupy  zacz"
		dta b(82)
		dta b(84)
		dta d"y  sra"
		dta b(79)
		dta d" z nieba!"
title_page1_1
		dta d"Dw"
		dta b(85)
		dta d"ch wsiowych bohater"
		dta b(85)
		dta d"w postanowi"
		dta b(84)
		dta d"o"
title_page1_2
		dta d"wyskroba"
		dta b(79)
		dta d" mas"
		dta b(82)
		dta d" fekaln"
		dta b(73)
		dta d" hydraulicznym"
title_page1_3
		dta d"wybierakiem. Jak najszybciej wyskrob"
title_page1_4
		dta d"g"
		dta b(85)
		dta d"wno z lataj"
		dta b(73)
		dta d"cych, kosmicznych dup!"
title_page1_5
		dta b(89+128)
		dta d"HELP"*
		dta b(89)
		dta d" - english version"

write_time
		; Hours
		lda hours
		clc
		adc #16
		sta screen+1222

		; Minutes
		lda minutes
		ldx #10
		jsr divByte
		clc
		adc #16
		sta screen+1225
		txa
		clc
		adc #16
		sta screen+1224

		; Seconds
		lda seconds
		ldx #10
		jsr divByte
		clc
		adc #16
		sta screen+1228
		txa
		clc
		adc #16
		sta screen+1227

		rts

time_string
		dta d"Time: 0:00:00"
shit_string
		dta d" Goo coverage:    % (  %)"

variables_init
		lda #1
		sta blink_clear
		lda #blink_delay
		sta blink_cnt

		lda #wyb_init_x
		sta HPOSP0
		sta wybierak_x

		lda #psh_ani_spd
		sta psh_fr_advc

		lda #wyb_init_x-8
		sta pusherL_X
		sta HPOSP3

		lda #wyb_init_x+8
		sta pusherR_X0
		sta HPOSM3
		clc
		adc #2
		sta pusherR_X1
		sta HPOSM2
		clc
		adc #2
		sta pusherR_X2
		sta HPOSM1
		clc
		adc #2
		sta pusherR_X3
		sta HPOSM0

		jsr initialize_enemy_position_and_direction

		lda #$ff
		sta	PCOLR1
		sta PCOLR2
		
		lda #col_excrements
		sta PCOLR0

		lda #0
		sta pusher_fram

		rts

chars_init
		jsr copy_charset
		jsr update_charset
		jsr switch_charset
		rts

switch_charset
		lda #>font_game
		sta CHBAS
		rts

update_charset
; Go through all chars
		ldy #0
upch01	tya
		pha

		lda font_game_addresses,y
		sta tmp_addr0
		lda font_game_addresses+1,y
		sta tmp_addr0+1
		ldy #0
		lda (tmp_addr0),y
		sta tmp_addr1
		iny
		lda (tmp_addr0),y
		sta tmp_addr1+1

; Copy single char
		ldy #2
upch00	lda (tmp_addr0),y
		dey
		dey
		sta (tmp_addr1),y
		iny
		iny
		iny
		cpy #$a
		bne upch00

		pla
		tay
		iny
		iny
		cpy #(num_chars*2)
		bne upch01

		rts

font_game_addresses
num_chars	equ	27
		dta a(font_game_char_00)
		dta a(font_game_char_01)
		dta a(font_game_char_02)
		dta a(font_game_char_03)
		dta a(font_game_char_04)
		dta a(font_game_char_05)
		dta a(font_game_char_06)
		dta a(font_game_char_07)
		dta a(font_game_char_08)
		dta a(font_game_char_09)
		dta a(font_game_char_0a)
		dta a(font_game_char_0b)
		dta a(font_game_char_0c)
		dta a(font_game_char_0d)
		dta a(font_game_char_0e)
		dta a(font_game_char_0f)
		dta a(font_game_char_10)
		dta a(font_game_char_11)
		dta a(font_game_char_12)
		dta a(font_game_char_13)
		dta a(font_game_char_14)
		dta a(font_game_char_15)
		dta a(font_game_char_16)
		dta a(font_game_char_17)
		dta a(font_game_char_18)
		dta a(font_game_char_19)
		dta a(font_game_char_1a)

font_game_char_00
		dta a(font_game+( 27*8)),b($1f),b($1f),b($3f),b($3d),b($3b),b($3b),b($7b),b($7b)	;	';'
font_game_char_01
		dta a(font_game+( 28*8)),b($ff),b($f7),b($ff),b($ef),b($ff),b($ef),b($ff),b($ef)	;	'<'
font_game_char_02
		dta a(font_game+( 29*8)),b($f8),b($fc),b($fc),b($dc),b($dc),b($de),b($de),b($df)	;	'='
font_game_char_03
		dta a(font_game+( 30*8)),b($77),b($f7),b($f7),b($6f),b($1f),b($3f),b($7f),b($7f)	;	'>'
font_game_char_04
		dta a(font_game+( 31*8)),b($ff),b($ff),b($ef),b($ff),b($bb),b($d7),b($ef),b($ef)	;	'?'
font_game_char_05
		dta a(font_game+( 32*8)),b($ef),b($ee),b($f4),b($f8),b($fc),b($fc),b($fe),b($fe)	;	'@'
font_game_char_06
		dta a(font_game+( 59*8)),b($ff),b($ff),b($ff),b($7f),b($7f),b($3f),b($1f),b($0f)	;	'['
font_game_char_07
		dta a(font_game+( 60*8)),b($ef),b($ff),b($ff),b($ff),b($ff),b($e7),b($c3),b($00)	;	'\'
font_game_char_08
		dta a(font_game+( 61*8)),b($fe),b($ff),b($ff),b($fe),b($fe),b($fc),b($f8),b($f0)	;	']'
font_game_char_09
		dta a(font_game+( 62*8)),b($46),b($f7),b($b8),b($f8),b($72),b($07),b($2b),b($06)	;	'^'
font_game_char_0a
		dta a(font_game+( 63*8)),b($03),b($2b),b($42),b($08),b($1c),b($59),b($c3),b($80)	;	'_'
font_game_char_0b
		dta a(font_game+( 11*8)),b($3e),b($41),b($55),b($41),b($22),b($3e),b($2a),b($0a)	;	'+'
font_game_char_0c
		dta a(font_game+( 15*8)),b($3c),b($76),b($5e),b($7e),b($66),b($24),b($24),b($20)	;	'/'
font_game_char_0d
		dta a(font_game+( 81*8)),b($48),b($e7),b($1c),b($91),b($8b),b($58),b($e5),b($1b)	;	'CTRL+Q'
font_game_char_0e
		dta a(font_game+(113*8)),b($6e),b($f5),b($02),b($b4),b($c7),b($98),b($e7),b($1e)	;	'q'
font_game_char_0f
		dta a(font_game+( 49*8)),b($0e),b($0a),b($0a),b($eb),b($eb),b($68),b($78),b($78)	;	'Q'
font_game_char_10
		dta a(font_game+( 76*8)),b($00),b($7e),b($42),b($5a),b($5a),b($42),b($7e),b($00)	;	'CTRL-L'
font_game_char_11
		dta a(font_game+( 53*8)),b($00),b($64),b($6c),b($78),b($70),b($60),b($7e),b($00)	;	'U'
font_game_char_12
		dta a(font_game+( 69*8)),b($18),b($10),b($7c),b($66),b($66),b($66),b($66),b($00)	;	'CTRL-E'
font_game_char_13
		dta a(font_game+( 82*8)),b($00),b($00),b($3c),b($66),b($7e),b($60),b($38),b($0e)	;	'CTRL-R'
font_game_char_14
		dta a(font_game+( 84*8)),b($00),b($38),b($18),b($1e),b($78),b($18),b($3c),b($00)	;	'CTRL-T'
font_game_char_15
		dta a(font_game+( 79*8)),b($0c),b($18),b($3c),b($60),b($60),b($60),b($3c),b($00)	;	'CTRL-O'
font_game_char_16
		dta a(font_game+( 85*8)),b($0c),b($18),b($3c),b($66),b($66),b($66),b($3c),b($00)	;	'CTRL-U'
font_game_char_17
		dta a(font_game+( 73*8)),b($00),b($00),b($3c),b($06),b($3e),b($66),b($3c),b($07)	;	'CTRL-I'
font_game_char_18
		dta a(font_game+( 58*8)),b($18),b($7e),b($16),b($0c),b($18),b($30),b($7e),b($00)	;	'Z'
font_game_char_19
		dta a(font_game+( 72*8)),b($ff),b($ff),b($fc),b($78),b($7c),b($3f),b($1f),b($07)
font_game_char_1a
		dta a(font_game+( 74*8)),b($ff),b($ff),b($3f),b($1e),b($3e),b($fc),b($f8),b($e0)

copy_charset
		ldy #0
coch00	lda CHARSET,y
		sta font_game,y
		lda CHARSET+$100,y
		sta font_game+$100,y
		lda CHARSET+$200,y
		sta font_game+$200,y
		lda CHARSET+$300,y
		sta font_game+$300,y
		iny
		cpy #$ff
		bne coch00
		rts

enemy_movement
		; Update color
		ldx PCOLR1
		inx
		stx PCOLR1
		stx PCOLR2

		; Consider delay
		ldx enemy_delay
		cpx #0
		beq enemo3
		dex
		stx enemy_delay
		rts
enemo4
		lda RANDOM
		sta enemy_delay
		jsr randomize_enemy_direction
		jmp enemo5
enemo3
		; Consider enemy pause for a moment
		lda RANDOM
		sec
		ldy shit_cover
		sbc enemy_stop_table-1,y
		bcc enemo4

		; Move enemy
enemo5	lda enemy_dir
		cmp #0
		beq enemo0

		; Move enemy right
		ldx enemy_x
		inx
		inx
		cpx #$fe
		beq enemo2
		ldy enemy_x1
		iny
		iny
		stx enemy_x
		stx HPOSP1
		sty enemy_x1
		sty HPOSP2
		rts
enemo2
		jsr initialize_enemy_position_and_direction
		jsr draw_enemy
		rts
enemo0
		; Move enemy left
		ldx enemy_x
		dex
		dex
		cpx #0
		beq enemo2
		ldy enemy_x1
		dey
		dey
		stx enemy_x
		stx HPOSP1
		sty enemy_x1
		sty HPOSP2
		rts

main_loop
		jsr synchro

		ldy CH
		cpy #$ff
		beq ml_7

		cpy #key_ESC
		bne ml_7
		jmp backtm

ml_7	lda #$ff
		sta CH

		ldx framecnt
		inx
		stx framecnt
		lda COLPM2
		cmp #1
		beq ml_9
		cpx #60
		bne ml_5
		jmp ml_a
ml_9	cpx #50
		bne ml_5

ml_a	; Advance time
		ldx seconds
		inx
		stx seconds
		cpx #60
		bne ml_6
		ldx minutes
		inx
		stx minutes
		ldy #0
		sty seconds
		cpx #60
		bne ml_6
		ldx hours
		inx
		stx hours
		ldy #0
		sty minutes
ml_6	ldx #0
		stx framecnt
		jsr	write_time

		; Collisions
		; $01 - wybierak, excrement
		; $04 - wybierak, obstacle type 1
		; $08 - wybierak, obstacle type 2

ml_5	lda P0PF
		sta ATRACT
		cmp #$01
		bne ml_0
		jsr shit_collected
ml_0	cmp #$04
		bne ml_1
		lda #$5a
		sta COLBK
		jsr shit_missed
ml_1	cmp #$08
		bne ml_2
		lda #$5a
		sta COLBK
		jsr shit_missed

ml_2
		lda P0PL
		sta HITCLR
		cmp #0
		beq ml_3

		; Collision with enemy
		lda #$5a
		sta COLBK
		jsr shit_missed
		jsr shit_missed

ml_3	jsr enemy_movement

		; Game process
		jsr spontaneous_ass_drift

		; Wybierak animation
		ldx wyb_fr_advc
		dex
		stx wyb_fr_advc
		cpx #0
		bne ml_4
		jsr wybierak_anim

ml_4	lda STICK0
		cmp #11
		jeq stick_left
		cmp #7
		jeq stick_right
		cmp #13
		jeq stick_down
		cmp #14
		jeq stick_up
		cmp #9
		jeq stick_left_down
		cmp #10
		jeq stick_left_up
		cmp #5
		jeq stick_right_down
		cmp #6
		jeq stick_right_up

		lda STICK1
		cmp #14
		bne ml_8
		jsr shit_collected

ml_8	jsr delay

		jmp main_loop

delay
		ldx #0
del0	nop
		inx
		cpx delay_t
		bne del0
		rts

;---- SHIT COLLECTED
;		jsr shit_collected
;		jsr delay
;		jmp main_loop
;---------------------

;---- SHIT MISSED
;		jsr shit_missed
;		jsr delay
;		jmp main_loop
;---------------------

stick_left_up
		jsr wybierak_left
		jsr wybierak_up
		jmp main_loop
stick_left_down
		jsr wybierak_left
		jsr wybierak_down
		jmp main_loop
stick_right_up
		jsr wybierak_right
		jsr wybierak_up
		jmp main_loop
stick_right_down
		jsr wybierak_right
		jsr wybierak_down
		jmp main_loop
stick_left
		jsr wybierak_left
		jsr delay
		jmp main_loop
stick_right
		jsr wybierak_right
		jsr delay
		jmp main_loop
stick_down
		jsr wybierak_down
		jmp main_loop
stick_up
		jsr wybierak_up
		jmp main_loop

wybierak_right
		ldx wybierak_x
		inx
		cpx #wyb_init_x+72
		beq wybri1
		stx wybierak_x
		stx HPOSP0

		; Move left pusher
		ldx pusherL_X
		inx
		stx pusherL_X
		stx HPOSP3

		; Move right pusher
		ldx pusherR_X0
		inx
		stx pusherR_X0
		stx HPOSM3
		ldx pusherR_X1
		inx
		stx pusherR_X1
		stx HPOSM2
		ldx pusherR_X2
		inx
		stx pusherR_X2
		stx HPOSM1
		ldx pusherR_X3
		inx
		stx pusherR_X3
		stx HPOSM0

		; Animate pusher
		ldx psh_fr_advc
		dex
		stx psh_fr_advc
		cpx #0
		bne wybri1

		ldx pusher_fram
		inx
		stx pusher_fram
		cpx #3
		bne wybri2
		ldx #0
		stx pusher_fram
wybri2
		jsr anim_pusher_legs
		lda #psh_ani_spd
		sta psh_fr_advc


wybri1	rts

version_string
		dta d"v1.3"*

wybierak_left
		ldx wybierak_x
		dex
		cpx #wyb_init_x-70
		beq wyble1
		stx wybierak_x
		stx HPOSP0

		; Move left pusher
		ldx pusherL_X
		dex
		stx pusherL_X
		stx HPOSP3

		; Move right pusher
		ldx pusherR_X0
		dex
		stx pusherR_X0
		stx HPOSM3
		ldx pusherR_X1
		dex
		stx pusherR_X1
		stx HPOSM2
		ldx pusherR_X2
		dex
		stx pusherR_X2
		stx HPOSM1
		ldx pusherR_X3
		dex
		stx pusherR_X3
		stx HPOSM0

		; Animate pusher
		ldx psh_fr_advc
		dex
		stx psh_fr_advc
		cpx #0
		bne wyble1

		ldx pusher_fram
		inx
		stx pusher_fram
		cpx #3
		bne wyble2
		ldx #0
		stx pusher_fram
wyble2
		jsr anim_pusher_legs
		lda #psh_ani_spd
		sta psh_fr_advc

wyble1	rts

title_page0_0
		dta d"Alien spaceships have invaded Earth!"
title_page0_1
		dta d"Two brave heroes decided to use hyd-"
title_page0_2
		dta d"raulic  extractor to  render  aliens"
title_page0_3
		dta d"defenseless. Steal all the sinister,"
title_page0_4
		dta d"brown nuke bombs from  the Invaders!"
title_page0_5
		dta b(89+128)
		dta d"HELP"*
		dta b(89)
		dta d" -  polish version"

wybierak_down
		ldx wybierak_y
		cpx #wyb_max_y
		beq wydo4
		inx
		stx wybierak_y

		ldy #6*8+wyb_init_y
wydo0	dey
		dey
		lda pmg_wybier,y
		iny
		sta pmg_wybier,y
		cpy wybierak_y
		bne wydo0
		dey
		lda #$0
		sta pmg_wybier,y

		; Move "excrement start" DLI
		lda #%00001011
		ldy dl_excreml
		sta dl_game,y
		iny
		sty dl_excreml
		lda #%10001011
		sta dl_game,y
		ldy dli_excrem
		iny
		sty dli_excrem

		; Calculate shit coverage
wydo2	lda dl_excreml
		clc
		adc shit_cover
		tay
		sec
		sbc #shit_maxpos
		bcs wydo3

		; Setup DLI accordingly
		lda #%00001011
		sta dl_game,y
		iny
		lda #%10001011
		sta dl_game,y

		ldx shit_cover
		cpx #38
		bne wydo3

		jmp winner

wydo3	rts
wydo4	jsr delay
		rts


wybierak_up
		ldx wybierak_y
		cpx #wyb_init_y
		beq wyup4
		dex
		stx wybierak_y

		ldy wybierak_y
wyup0	iny
		lda pmg_wybier,y
		cmp #$ff			; $ff is the first char of wybierak-base
		beq wyup1 
		dey
		cpy #wyb_init_y
		sta pmg_wybier,y
		iny
		bne wyup0

wyup1
		; Load one missing line of the wybierak (to appear
		; directly above the wybierak-base)
		lda #wyb_max_y+$0a
		sec
		sbc wybierak_y
		tay
		lda wybierak_data,y
		sta pmg_wybier+wyb_base_of

		; Move "excrement start" DLI
		lda #%00001011
		ldy dl_excreml
		sta dl_game,y
		dey
		sty dl_excreml
		lda #%10001011
		sta dl_game,y
		ldy dli_excrem
		dey
		sty dli_excrem

		; Calculate shit coverage
wyup2	lda dl_excreml
		clc
		adc shit_cover
		tay
		iny
		iny
		sec
		sbc #shit_maxpos
		bcs wyup3

		; Setup DLI accordingly
		lda #%00001011
		sta dl_game,y
		dey
		lda #%10001011
		sta dl_game,y
wyup3	rts
wyup4	jsr delay
		rts

write_shit_cover
		lda #0
		sta screen+1247
		; 1 = 0%, 38 = 100%
		ldy shit_cover
		cpy #38
		beq wrshco1
		lda shit_percent_table-1,y
		ldx #10
		jsr divByte
		clc
		adc #16
		sta screen+1248
		cpx #0
		beq wrshco0
		txa
		clc
		adc #16
		sta screen+1247
		jmp wrshco0
wrshco1 lda #127
		sta screen+1246
		sta screen+1247
		lda #0
		sta screen+1248
		sta screen+1253
		lda #17
		sta screen+1249
		lda #16
		sta screen+1250
		sta screen+1251
		lda #5
		sta screen+1252
		lda #126
		sta screen+1254
		sta screen+1255
wrshco2	rts
wrshco0	ldy shitmax
		lda shit_percent_table-1,y
		ldx #10
		jsr divByte
		clc
		adc #16
		sta screen+1253
		cpx #0
		beq wrshco2
		txa
		clc
		adc #16
		sta screen+1252
		rts

drift_reconsideration_table
		dta b(1)
		dta b(1)
		dta b(1)
		dta b(2)
		dta b(2)
		dta b(2)
		dta b(3)
		dta b(3)
		dta b(3)
		dta b(4)
		dta b(4)
		dta b(4)
		dta b(5)
		dta b(5)
		dta b(5)
		dta b(6)
		dta b(6)
		dta b(6)
		dta b(7)
		dta b(7)
		dta b(7)
		dta b(8)
		dta b(8)
		dta b(8)
		dta b(9)
		dta b(9)
		dta b(9)
		dta b(10)
		dta b(10)
		dta b(10)
		dta b(11)
		dta b(11)
		dta b(11)
		dta b(12)
		dta b(12)
		dta b(12)
		dta b(13)
		dta b(13)

enemy_stop_table
		dta b(1)
		dta b(1)
		dta b(1)
		dta b(1)
		dta b(2)
		dta b(2)
		dta b(2)
		dta b(2)
		dta b(3)
		dta b(3)
		dta b(3)
		dta b(3)
		dta b(4)
		dta b(4)
		dta b(4)
		dta b(4)
		dta b(5)
		dta b(5)
		dta b(5)
		dta b(6)
		dta b(6)
		dta b(6)
		dta b(6)
		dta b(7)
		dta b(7)
		dta b(7)
		dta b(7)
		dta b(8)
		dta b(8)
		dta b(8)
		dta b(8)
		dta b(9)
		dta b(9)
		dta b(9)
		dta b(9)
		dta b(10)
		dta b(10)
		dta b(10)

obstacle_prob_table
		dta b(50)
		dta b(54)
		dta b(59)
		dta b(64)
		dta b(68)
		dta b(73)
		dta b(78)
		dta b(83)
		dta b(87)
		dta b(92)
		dta b(97)
		dta b(102)
		dta b(106)
		dta b(111)
		dta b(116)
		dta b(121)
		dta b(125)
		dta b(130)
		dta b(135)
		dta b(140)
		dta b(144)
		dta b(149)
		dta b(154)
		dta b(158)
		dta b(163)
		dta b(168)
		dta b(173)
		dta b(177)
		dta b(182)
		dta b(187)
		dta b(192)
		dta b(196)
		dta b(201)
		dta b(206)
		dta b(211)
		dta b(215)
		dta b(220)
		dta b(225)

excrem_prob_table
		dta b(200)
		dta b(195)
		dta b(190)
		dta b(185)
		dta b(181)
		dta b(176)
		dta b(171)
		dta b(166)
		dta b(162)
		dta b(157)
		dta b(152)
		dta b(147)
		dta b(143)
		dta b(138)
		dta b(133)
		dta b(128)
		dta b(124)
		dta b(119)
		dta b(114)
		dta b(110)
		dta b(105)
		dta b(100)
		dta b(95)
		dta b(91)
		dta b(86)
		dta b(81)
		dta b(76)
		dta b(72)
		dta b(67)
		dta b(62)
		dta b(57)
		dta b(53)
		dta b(48)
		dta b(43)
		dta b(38)
		dta b(34)
		dta b(29)
		dta b(24)

shit_percent_table
		dta b(2)
		dta b(5)
		dta b(7)
		dta b(10)
		dta b(13)
		dta b(15)
		dta b(18)
		dta b(21)
		dta b(23)
		dta b(26)
		dta b(28)
		dta b(31)
		dta b(34)
		dta b(36)
		dta b(39)
		dta b(42)
		dta b(44)
		dta b(47)
		dta b(50)
		dta b(52)
		dta b(55)
		dta b(57)
		dta b(60)
		dta b(63)
		dta b(65)
		dta b(68)
		dta b(71)
		dta b(73)
		dta b(76)
		dta b(78)
		dta b(81)
		dta b(84)
		dta b(86)
		dta b(89)
		dta b(92)
		dta b(94)
		dta b(97)

shit_collected
		ldx shit_cover
		inx
		stx shit_cover
		lda shitmax
		sec
		sbc shit_cover
		bcc shicol3
shicol4	jsr write_shit_cover
		lda wybierak_x
		sec
		sbc #wyb_init_x-69
		lsr
		lsr
		lsr
		tay
		iny

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; My 2.5 year old daughter Rozalka found this bug during betatesting :)
; She saved me two bytes of RAM :)
;		iny
;		iny	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		iny
		ldx #0
shicol2	lda (excrement),y
		cmp #c_excreme1
		beq shicol0
		cmp #c_excreme2
		beq shicol0
		iny
		inx
		cpx #3
		bne shicol2
shicol0	lda #0
		sta (excrement),y
shicol1	jsr wydo2
		rts
shicol3	ldx shitmax
		inx
		stx shitmax
		ldx shit_cover
		cpx #38
		bne shicol4
		jmp winner

write_winning_time
		; Hours
		lda hours
		clc
		adc #16
		sta screen+456+6

		lda #26
		sta screen+460+6
		sta screen+457+6

		; Minutes
		lda minutes
		ldx #10
		jsr divByte
		clc
		adc #16
		sta screen+459+6
		txa
		clc
		adc #16
		sta screen+458+6

		; Seconds
		lda seconds
		ldx #10
		jsr divByte
		clc
		adc #16
		sta screen+462+6
		txa
		clc
		adc #16
		sta screen+461+6

		rts

shit_missed
		ldx shit_cover
		cpx #shitco_init
		beq shimi0 
		dex
		stx shit_cover
		jsr write_shit_cover
		jsr wydo2
shimi0	rts

spontaneous_ass_drift
		jsr reconsider_drift_parameters
		lda drift_spd
		and #%10000000
		cmp #0
		beq sad1
		jsr asses_right
		jmp sad0
sad1	jsr asses_left
sad0	rts

reconsider_drift_parameters
		lda RANDOM
		sec
		ldy shit_cover
		sbc drift_reconsideration_table-1,y
		bcs recdp0
		jsr initialize_drift
recdp0	rts

winner_row_0_en
		dta d"shit collection time"

asses_left
		ldy scrol
		dey
		lda drift_spd
		and #%00000001
		cmp #%00000000
		beq assle0
		dey
assle0	cpy #$fe
		beq asses_copy_left
		cpy #$ff
		beq asses_copy_left
asses_left_after_copy
		sty scrol
		sty HSCROL
asses_left_fin
		rts
asses_copy_left
		ldy #1
		ldx #$ff
asses_copy_left_loop
		inx
		cpx #23
		beq asses_left_finished_copying
		lda (assbp),y
		dey
		sta (assbp),y
		iny
		lda (assbp_mid),y
		dey
		sta (assbp_mid),y
		iny
		lda (excrement),y
		dey
		sta (excrement),y
		iny
		lda (assbp_low),y
		dey
		sta (assbp_low),y
		iny
		iny
		jmp asses_copy_left_loop
asses_left_finished_copying
		jsr asses_spawn_on_the_right
		ldy #7
		jmp asses_left_after_copy
asses_spawn_on_the_right
		; Clear excrement on the right
		ldy #23
		lda #0
		sta (excrement),y

		; Load one-before-last character on the right
		dey
		lda (assbp),y

		; Spawn new char accordingly to the following formula:
		; A = $00  ---> spawn ($40, $40, $40)
		; A = $40  ---> spawn ($80, $80, $80)
		; A = $80  ---> spawn ($00, $00, $00) or ($9b, $9e, $bb) or ($5b, $5e, $7b)

		; A = $9b  ---> spawn ($9c, $9f, $bc)
		; A = $9c  ---> spawn ($9d, $a0, $bd)
		; A = $9d  ---> spawn ($00, $00, $00) or ($9b, $9e, $bb) or ($5b, $5e, $7b)

		; A = $5b  ---> spawn ($5c, $5f, $7c)
		; A = $5c  ---> spawn ($5d, $60, $7d)
		; A = $5d  ---> spawn ($00, $00, $00) or ($9b, $9e, $bb) or ($5b, $5e, $7b)

		cmp #$00
		bne asses_left_00
		lda #$40
		pha
		pha
		pha
		jmp asses_finish_spawning_on_the_right
asses_left_00
		cmp #$40
		bne asses_left_01
		lda #$80
		pha
		pha
		pha
		jsr consider_spawning_an_obstacle_on_the_right
		jmp asses_finish_spawning_on_the_right
asses_left_01
		cmp #$80
		bne asses_left_02
		jsr do_random_v1
		jsr consider_spawning_an_obstacle_on_the_right
		jmp asses_finish_spawning_on_the_right
asses_left_02
		cmp #$9b
		bne asses_left_03
		lda #$9c
		pha
		jsr consider_spawning_an_excrement_on_the_right
		lda #$9f
		pha
		lda #$bc
		pha
		jmp asses_finish_spawning_on_the_right
asses_left_03
		cmp #$9c
		bne asses_left_04
		lda #$9d
		pha
		lda #$a0
		pha
		lda #$bd
		pha
		jsr consider_spawning_an_obstacle_on_the_right
		jmp asses_finish_spawning_on_the_right
asses_left_04
		cmp #$9d
		bne asses_left_05
		jsr do_random_v1
		jsr consider_spawning_an_obstacle_on_the_right
		jmp asses_finish_spawning_on_the_right
asses_left_05
		cmp #$5b
		bne asses_left_06
		lda #$5c
		pha
		lda #$5f
		pha
		lda #$7c
		pha
		jsr consider_spawning_an_obstacle_on_the_right
		jmp asses_finish_spawning_on_the_right
asses_left_06
		cmp #$5c
		bne asses_left_07
		lda #$5d
		pha
		lda #$60
		pha
		lda #$7d
		pha
		jsr consider_spawning_an_obstacle_on_the_right
		jmp asses_finish_spawning_on_the_right
asses_left_07
		; So, this must be $5d - no other way
		jsr do_random_v1
		jsr consider_spawning_an_obstacle_on_the_right
asses_finish_spawning_on_the_right
		iny
		pla
		sta (assbp_low),y
		pla
		sta (assbp_mid),y
		pla
		sta (assbp),y
		rts
do_random_v1
		; Remeber return address
		pla
		sta tmp01
		pla
		tax

		;($00, $00, $00) or ($9b, $9e, $bb) or ($5b, $5e, $7b)
		lda RANDOM
		sec
		sbc #100
		bcc do_random_v1_1
		sec
		sbc #100
		bcc do_random_v1_2
		lda #$00
		pha
		pha
		pha
		jmp do_random_v1_finish
pusherR_legs1_data
		dta b($0a),b($12),b($12),b($0a)
do_random_v1_1
		lda #$9b
		pha
		lda #$9e
		pha
		lda #$bb
		pha
		jmp do_random_v1_finish
do_random_v1_2
		lda #$5b
		pha
		lda #$5e
		pha
		lda #$7b
		pha
do_random_v1_finish
		txa
		pha
		lda tmp01
		pha
		rts

do_random_v2
		; Remeber return address
		pla
		sta tmp01
		pla
		tax

		;($80, $80, $80) or ($9d, $a0, $bd) or ($5d, $60, $7d)
		lda RANDOM
		sec
		sbc #100
		bcc do_random_v2_1
		sec
		sbc #100
		bcc do_random_v2_2
		lda #$80
		pha
		pha
		pha
		jmp do_random_v2_finish
do_random_v2_1
		lda #$9d
		pha
		lda #$a0
		pha
		lda #$bd
		pha
		jmp do_random_v2_finish
do_random_v2_2
		lda #$5d
		pha
		lda #$60
		pha
		lda #$7d
		pha
do_random_v2_finish
		txa
		pha
		lda tmp01
		pha
		rts
consider_spawning_an_obstacle_on_the_right
		lda RANDOM
		sec
		sty tmp01
		ldy shit_cover
		sbc obstacle_prob_table-1,y
		ldy tmp01
		bcs csano0
		lda obsta_rand
		iny
		sta (excrement),y
		dey
		jsr randomize_obstacle
csano0	rts
consider_spawning_an_excrement_on_the_right
		lda RANDOM
		sec
		sty tmp01
		ldy shit_cover
		sbc excrem_prob_table-1,y
		ldy tmp01
		bcs csan0
		lda excre_rand
		iny
		sta (excrement),y
		dey
		jsr randomize_excrement
csan0	rts
consider_spawning_an_excrement_on_the_left
		lda RANDOM
		sec
		sty tmp01
		ldy shit_cover
		sbc excrem_prob_table-1,y
		ldy tmp01
		bcs csan1
		lda excre_rand
		dey
		sta (excrement),y
		iny
		jsr randomize_excrement
csan1	rts
consider_spawning_an_obstacle_on_the_left
		lda RANDOM
		sec
		sty tmp01
		ldy shit_cover
		sbc obstacle_prob_table-1,y
		ldy tmp01
		bcs csano1
		lda obsta_rand
		dey
		sta (excrement),y
		iny
		jsr randomize_obstacle
csano1	rts
randomize_excrement
		pha
		ldx #c_excreme1
		lda RANDOM
		and #%10000000
		cmp #$80
		beq ranex0
		ldx #c_excreme2
ranex0	stx excre_rand
		pla
		rts
randomize_obstacle
		pha
		ldx #c_obsta1
		lda RANDOM
		and #%10000000
		cmp #$80
		beq ranobs0
		ldx #c_obsta2
ranobs0	stx obsta_rand
		pla
		rts
asses_right
		ldy scrol
		iny
		lda drift_spd
		and #%00000001
		cmp #%00000000
		beq assri0
		iny
assri0	cpy #8
		beq asses_copy_right
		cpy #9
		beq asses_copy_right
asses_right_after_copy
		sty scrol
		sty HSCROL
asses_right_fin
		rts
asses_copy_right
		ldy #22
		ldx #$ff
asses_copy_right_loop
		inx
		cpx #23
		beq asses_right_finished_copying
		lda (assbp),y
		iny
		sta (assbp),y
		dey
		lda (assbp_mid),y
		iny
		sta (assbp_mid),y
		dey
		lda (excrement),y
		iny
		sta (excrement),y
		dey
		lda (assbp_low),y
		iny
		sta (assbp_low),y

		dey
		dey
		jmp asses_copy_right_loop
asses_right_finished_copying
		jsr asses_spawn_on_the_left
		ldy #0
		jmp asses_right_after_copy
asses_spawn_on_the_left
		; Clear excrement on the left
		ldy #0
		lda #0
		sta (excrement),y

		; Load one-after-first character on the left
		iny
		lda (assbp),y

		; Spawn new char accordingly to the following formula:
		; A = $00  ---> spawn ($80, $80, $80) or ($9d, $a0, $bd) or ($5d, $60, $7d)
		; A = $40  ---> spawn ($00, $00, $00)
		; A = $80  ---> spawn ($40, $40, $40)

		; A = $9b  ---> spawn ($80, $80, $80) or ($9d, $a0, $bd) or ($5d, $60, $7d)
		; A = $9c  ---> spawn ($9b, $9e, $bb)
		; A = $9d  ---> spawn ($9c, $9f, $bc)

		; A = $5b  ---> spawn ($80, $80, $80) or ($9d, $a0, $bd) or ($5d, $60, $7d)
		; A- = $5c  ---> spawn ($5b, $5e, $7b)
		; A = $5d  ---> spawn ($5c, $5f, $7c)

		cmp #$00
		bne asses_right_00
		jsr do_random_v2
		jmp asses_finish_spawning_on_the_left
asses_right_00
		cmp #$40
		bne asses_right_01
		lda #$00
		pha
		pha
		pha
		jsr consider_spawning_an_obstacle_on_the_left
		jmp asses_finish_spawning_on_the_left
asses_right_01
		cmp #$80
		bne asses_right_02
		lda #$40
		pha
		pha
		pha
		jsr consider_spawning_an_obstacle_on_the_left
		jmp asses_finish_spawning_on_the_left
asses_right_02
		cmp #$9b
		bne asses_right_03
		jsr do_random_v2
		jsr consider_spawning_an_obstacle_on_the_left
		jmp asses_finish_spawning_on_the_left
asses_right_03
		cmp #$9c
		bne asses_right_04
		lda #$9b
		pha
		lda #$9e
		pha
		lda #$bb
		pha
		jsr consider_spawning_an_obstacle_on_the_left
		jmp asses_finish_spawning_on_the_left
asses_right_04
		cmp #$9d
		bne asses_right_05
		lda #$9c
		pha
		jsr consider_spawning_an_excrement_on_the_left
		lda #$9f
		pha
		lda #$bc
		pha
		jmp asses_finish_spawning_on_the_left
asses_right_05
		cmp #$5b
		bne asses_right_06
		jsr do_random_v2
		jsr consider_spawning_an_obstacle_on_the_left
		jmp asses_finish_spawning_on_the_left
asses_right_06
		cmp #$5c
		bne asses_right_07
		lda #$5b
		pha
		lda #$5e
		pha
		lda #$7b
		pha
		jsr consider_spawning_an_obstacle_on_the_left
		jmp asses_finish_spawning_on_the_left
asses_right_07
		; So, this must be $5d - no other way
		lda #$5c
		pha
		jsr consider_spawning_an_excrement_on_the_left
		lda #$5f
		pha
		lda #$7c
		pha
asses_finish_spawning_on_the_left
		dey
		pla
		sta (assbp_low),y
		pla
		sta (assbp_mid),y
		pla
;		jsr consider_spawning_an_obstacle_on_the_left
		sta (assbp),y

		rts

screen_init
		; normal screen width
		lda #%00100010				
		sta SDMCTL

		; DL setup
		ldx <dl_menu
		ldy >dl_menu
		stx SDLSTL
		sty SDLSTL+1
		rts

time_string_pl
		dta d"Czas: 0:00:00"
shit_string_pl
		dta d"Obstolcowanie:    % (  %)"

clear_sprites_memory
		ldx <sprites_beg
		ldy >sprites_beg
		stx tmp_addr0
		sty tmp_addr0+1
		ldx <sprites_end
		ldy >sprites_end
		stx tmp_addr1
		sty tmp_addr1+1
		ldy #0
		ldx #0
clspme0	txa
		sta (tmp_addr0),y
		clc
		lda tmp_addr0
		adc #<1
		sta tmp_addr0
		lda tmp_addr0+1
		adc #>1
		sta tmp_addr0+1
		cmp tmp_addr1+1
		bne clspme0
		lda tmp_addr0
		cmp tmp_addr1
		bne clspme0
		rts

anim_pusher_legs
		ldy #0
		lda pusher_fram
		cpx #0
		beq anpule0

		; 1 or 2
		cpx #1
		beq anpule1

		; 2
anpule2
		lda pusherL_legs2_data,y
		sta pmg_pusherL+pusher_y+7,y
		lda pusherR_legs2_data,y
		sta pmg_pusherR+pusher_y+7,y
		iny
		cpy #4
		bne anpule2
		rts

anpule0
		lda pusherL_legs0_data,y
		sta pmg_pusherL+pusher_y+7,y
		lda pusherR_legs0_data,y
		sta pmg_pusherR+pusher_y+7,y
		iny
		cpy #4
		bne anpule0
		rts

anpule1
		lda pusherL_legs1_data,y
		sta pmg_pusherL+pusher_y+7,y
		lda pusherR_legs1_data,y
		sta pmg_pusherR+pusher_y+7,y
		iny
		cpy #4
		bne anpule1
		rts

copy_status_bars
		ldy #0
costba0	lda screen+1156,y
		sta screen+876,y
		lda screen+1156+60,y
		sta screen+876+60,y
		iny
		cpy #40
		bne costba0
		rts

draw_pushers
		ldy #0
drpus0	lda pusherL_fr0_data,y
		sta pmg_pusherL+pusher_y,y
		lda pusherR_fr0_data,y
		sta pmg_pusherR+pusher_y,y
		iny
		cpy #11
		bne drpus0
		lda #col_pusherL
		sta PCOLR3
		lda #col_pusherR
		sta COLOR3
		rts

pusherL_fr0_data
		dta b($0c),b($0c),b($09)
		dta b($0f),b($10),b($10),b($20)
pusherL_legs0_data
		dta b($50),b($48),b($48),b($50)
pusherL_legs1_data
		dta b($50),b($50),b($50),b($50)
pusherR_fr0_data
		dta b($30),b($30),b($90)
		dta b($f0),b($08),b($08),b($04)
pusherR_legs0_data
		dta b($0c),b($0c),b($14),b($14)
pusherR_legs2_data
		dta b($0a),b($0a),b($0a),b($0a)

draw_wybierak
		ldy #0
drwyb0	lda wybierak_data,y
		sta pmg_wybier+wyb_init_y,y
		iny
		cpy #(7*8)
		bne drwyb0
		rts

wybierak_data
		dta b($42),b($81),b($42),b($42),b($24),b($7e),b($7e),b($3c)
		dta b($18),b($18),b($18),b($18),b($18),b($3c),b($18),b($18)
		dta b($3c),b($18),b($18),b($18),b($5a),b($5a),b($3c),b($18)
		dta b($18),b($18),b($3c),b($18),b($18),b($3c),b($3c),b($3c)
		dta b($24),b($66),b($7e),b($3c),b($5a),b($5a),b($5a),b($5a)
		dta b($18),b($18),b($18),b($18),b($18),b($18),b($18),b($18)
		dta b($ff),b($7e),b($3c),b($3c),b($18),b($7e),b($3c),b($ff)

enable_sprites
		lda SDMCTL
		ora #%00001100
		sta SDMCTL

		lda >spr_PMBASE
		sta PMBASE

		lda #%00000011
		sta GRACTL
		rts

divbyte
		; A / X
		; Result in X, reminder in A
		stx tmp01
		ldx #0
divbyt1	sec
		sbc tmp01
		bcc divbyt0
		inx
		jmp divbyt1
divbyt0	clc
		adc tmp01
		rts

play_mortal
		ldx #0
		txa
		jsr player+3
		rts

play_winner
		ldx #1
		txa
		jsr player+3
		rts

play_kanikuly
		ldx #2
		txa
		jsr player+3
		rts

music_init
		ldx <music
		ldy >music
		lda #$70
		jsr player+3

		ldy <vbi_routine
        ldx >vbi_routine
        lda #7
        jsr SETVBV
		rts

clear_enemy
		ldy #0
		ldx enemy_y
clene0	lda #0
		sta pmg_enemyL+enemy_min_y,x
		iny
		inx
		cpy #(2*8)
		bne clene0
		ldy #0
		ldx enemy_y
clene1	sta pmg_enemyR+enemy_min_y,x
		iny
		inx
		cpy #(2*8)
		bne clene1
		rts

draw_enemy
		jsr clear_enemy

		; Calculate random height
		lda RANDOM
		ldx #$ff/($ff/(enemy_max_y-enemy_min_y))
		jsr divbyte
		stx enemy_y

		; Calculate random enemy
		lda RANDOM
		and #%00000001
		cmp #0
		beq drene2

		; Drawing first enemy
		lda #0
		sta tmp_addr1
		lda #(2*8)
		sta tmp_addr1+1
		jmp drene3
drene2
		; Drawing second enemy
		lda #16
		sta tmp_addr1
		lda #(2*8)+16
		sta tmp_addr1+1
drene3	ldy tmp_addr1
drene0	lda enemyL_data,y
		sta pmg_enemyL+enemy_min_y,x
		iny
		inx
		cpy tmp_addr1+1
		bne drene0
		ldy tmp_addr1
		ldx enemy_y
drene1	lda enemyR_data,y
		sta pmg_enemyR+enemy_min_y,x
		iny
		inx
		cpy tmp_addr1+1
		bne drene1
		rts

enemyL_data
		dta b($1c),b($3f),b($77),b($63),b($e1),b($e5),b($f1),b($ff)
		dta b($fd),b($7f),b($0f),b($0d),b($0d),b($0d),b($08),b($08)

		dta b($1f),b($61),b($88),b($92),b($40),b($78),b($07),b($03)
		dta b($03),b($03),b($05),b($05),b($04),b($08),b($0c),b($03)

enemyR_data
		dta b($38),b($7c),b($ee),b($c6),b($87),b($a7),b($8f),b($fe)
		dta b($7e),b($fc),b($f8),b($58),b($58),b($50),b($50),b($10)

		dta b($e0),b($10),b($8e),b($21),b($89),b($06),b($f8),b($c0)
		dta b($c0),b($c0),b($c0),b($e0),b($e0),b($70),b($f0),b($c0)

sprites_init
		jsr clear_sprites_memory

		jsr draw_wybierak
		jsr draw_enemy
		jsr draw_pushers

		ldy #0
		sty SIZEP0
		sty SIZEP1
		sty SIZEP2
		sty SIZEP3
		ldy #%10101010
		sty SIZEM

		jsr enable_sprites

		; Missiles as 5th player
		lda GPRIOR
		ora #%00010000
		sta GPRIOR

		rts

excrement_chain_init
		ldy #0
		lda #0
exci5	sta (excrement),y
		iny
		cpy #25
		bne exci5

		ldy #1
exci0	lda (assbp),y
		and #%00011100		; Check whether $9b or $5b
		cmp #$1c
		beq exci1
exci2	iny
		iny
		iny
		cpy #22
		beq exci3 
		jmp exci0
exci1
		lda RANDOM
		sec
		sty tmp01
		ldy shit_cover
		sbc excrem_prob_table-1,y
		ldy tmp01
		bcs exci4
		lda excre_rand
		sta (excrement),y
exci4	jsr randomize_excrement
		jmp exci2
exci3	rts	

synchro
		lda COLPM2
		cmp #1
		bne synchr1
		; PAL
		lda #$90
		jmp synchr2
synchr1 ; NTSC
		lda #$7c
synchr2	cmp VCOUNT
		bne synchr2
		rts

ass_chain_init
		; 0 = Empty
		; 1 = Ass Type #1
		; 2 = Ass Type #2
		; 3 = ...

		ldy #0
		ldx #0

		; 000-100 = 1
		; 101-200 = 2
		; 201-255 = 0

assch3	
		lda RANDOM
		sec
		sbc #100
		bcc assch0
		sec
		sbc #100
		bcc assch1
		
		jsr spawn_empty
		jmp assch2
assch0
		jsr spawn_ass1
		jmp assch2
assch1
		jsr spawn_ass2

assch2	inx
		cpx #8
		bne assch3
		rts

spawn_ass1
		lda #27+128
		sta (assbp),y
		iny
		lda #28+128
		sta (assbp),y
		iny
		lda #29+128
		sta (assbp),y
		iny

		dey
		dey
		dey

		lda #30+128
		sta (assbp_mid),y
		iny
		lda #31+128
		sta (assbp_mid),y
		iny
		lda #32+128
		sta (assbp_mid),y
		iny

		dey
		dey
		dey

		lda #59+128
		sta (assbp_low),y
		iny
		lda #60+128
		sta (assbp_low),y
		iny
		lda #61+128
		sta (assbp_low),y
		iny

		rts

time_init
		lda #0
		sta hours
		sta minutes
		sta seconds
		rts

coverage_init
		jsr write_shit_cover
		rts

draw_title_page0
		ldy #0

		lda polish
		cmp #1
		beq dtp00a

dtp00	lda title_page0_0,y
		sta screen+236+40*1+2,y
		iny
		cpy #36
		bne dtp00
		ldy #0
dtp01	lda title_page0_1,y
		sta screen+236+40*2+2,y
		iny
		cpy #36
		bne dtp01
		ldy #0
dtp02	lda title_page0_2,y
		sta screen+236+40*3+2,y
		iny
		cpy #36
		bne dtp02
		ldy #0
dtp03	lda title_page0_3,y
		sta screen+236+40*4+2,y
		iny
		cpy #36
		bne dtp03
		ldy #0
dtp04	lda title_page0_4,y
		sta screen+236+40*5+2,y
		iny
		cpy #36
		bne dtp04
		ldy #0
dtp05	lda title_page0_5,y
		sta screen+250+40*7+2,y
		iny
		cpy #24
		bne dtp05
		rts
dtp00a	lda title_page1_0,y
		sta screen+236+40*1+2,y
		iny
		cpy #36
		bne dtp00a
		ldy #0
dtp01a	lda title_page1_1,y
		sta screen+236+40*2+2,y
		iny
		cpy #36
		bne dtp01a
		ldy #0
dtp02a	lda title_page1_2,y
		sta screen+236+40*3+2,y
		iny
		cpy #36
		bne dtp02a
		ldy #0
dtp03a	lda title_page1_3,y
		sta screen+236+40*4+2,y
		iny
		cpy #36
		bne dtp03a
		ldy #0
dtp04a	lda title_page1_4,y
		sta screen+236+40*5+2,y
		iny
		cpy #36
		bne dtp04a
		ldy #0
dtp05a	lda title_page1_5,y
		sta screen+250+40*7+2,y
		iny
		cpy #24
		bne dtp05a
		rts

spawn_ass2
		lda #27+64
		sta (assbp),y
		iny
		lda #28+64
		sta (assbp),y
		iny
		lda #29+64
		sta (assbp),y
		iny

		dey
		dey
		dey

		lda #30+64
		sta (assbp_mid),y
		iny
		lda #31+64
		sta (assbp_mid),y
		iny
		lda #32+64
		sta (assbp_mid),y
		iny

		dey
		dey
		dey

		lda #59+64
		sta (assbp_low),y
		iny
		lda #60+64
		sta (assbp_low),y
		iny
		lda #61+64
		sta (assbp_low),y
		iny

		rts

spawn_empty
		lda #0
		sta (assbp),y
		iny
		lda #0+64
		sta (assbp),y
		iny
		lda #0+128
		sta (assbp),y
		iny

		dey
		dey
		dey

		lda #0
		sta (assbp_mid),y
		iny
		lda #0+64
		sta (assbp_mid),y
		iny
		lda #0+128
		sta (assbp_mid),y
		iny

		dey
		dey
		dey

		lda #0
		sta (assbp_low),y
		iny
		lda #0+64
		sta (assbp_low),y
		iny
		lda #0+128
		sta (assbp_low),y
		iny

		rts

initialize_drift
		lda RANDOM
		sta drift_spd
		rts

wybierak_init
		lda #wyb_ani_spd
		sta wyb_fr_advc

		lda #0
		sta wybierak_fr

		ldx #wyb_y_st_o
wybini0	txa
		pha
		jsr wybierak_down
		pla
		tax
		dex
		cpx #0
		bne wybini0
		rts

engine_init
		cld

		; Initial excrement location
		lda #excrem_init
		sta HITCLR			; :-)
		sta dli_excrem
		lda #excrem_dlii
		sta dl_excreml
		lda #1
		sta dli_exc_up
		lda #shitco_init
		sta shit_cover
		sta shitmax

		; Initial wybierak position
		lda #wyb_init_y
		sta wybierak_y

		; Excrement type 1 as a starting point
		lda #c_excreme1
		sta excre_rand

		; Obstacle type 1 as a starting point
		lda #c_obsta1
		sta obsta_rand

		; Color for excrements
		lda #col_excrements
		sta COLOR0

		; Set up default drift and direction
		jsr initialize_drift

		; No scroll and empty frame counter
		lda #0
		sta scrol
		sta framecnt

		; Init pointers to the 3 ass rows and for the excrement row
		lda #<(screen+24)
		sta assbp_mid
		lda #>(screen+24)
		sta assbp_mid+1

		lda #<(screen+48)
		sta assbp_low
		lda #>(screen+48)
		sta assbp_low+1

		lda #<(screen+72)
		sta excrement
		lda #>(screen+72)
		sta excrement+1

		lda #<screen
		sta assbp
		lda #>screen
		sta assbp+1

		; Init DLI
		lda <dli_routine
		sta VDSLST
		lda >dli_routine
		sta VDSLST+1
		lda #192
		sta NMIEN

		; Init shit trail
		lda #shit_begin
		sta shittrail
		tay
		lda dl_game,y
		ora #%10000000
		sta dl_game,y

		rts

hide_sprites
		lda #0
		sta HPOSP0
		sta HPOSP1
		sta HPOSP2
		sta HPOSP3
		sta HPOSM0
		sta HPOSM1
		sta HPOSM2
		sta HPOSM3
		rts

wybierak_anim
		ldx #wyb_ani_spd
		stx wyb_fr_advc

		ldx wybierak_fr
		cpx #3
		beq wybani0
		inx
		stx wybierak_fr
		jmp wybani1
wybani0 ldx #0
		stx wybierak_fr
wybani1 

		cpx #0
		bne wybani4
		ldx <wybierak_fr_0
		ldy >wybierak_fr_0
		stx tmp_addr0
		sty tmp_addr0+1
		jmp wybani3

wybani4	cpx #1
		bne wybani5
		ldx <wybierak_fr_1
		ldy >wybierak_fr_1
		stx tmp_addr0
		sty tmp_addr0+1
		jmp wybani3

wybani5	cpx #2
		bne wybani6
		ldx <wybierak_fr_2
		ldy >wybierak_fr_2
		stx tmp_addr0
		sty tmp_addr0+1
		jmp wybani3

wybani6 ldx <wybierak_fr_1
		ldy >wybierak_fr_1
		stx tmp_addr0
		sty tmp_addr0+1

wybani3
		ldx <pmg_wybier
		ldy >pmg_wybier
		stx tmp_addr1
		sty tmp_addr1+1

		ldy wybierak_y
		sty tmp01
		ldy #0
		sty tmp02
		ldx #0
wybani2	
		ldy tmp02
		lda (tmp_addr0),y
		iny
		sty tmp02
		ldy tmp01
		sta (tmp_addr1),y
		iny
		sty tmp01
		inx
		cpx #5
		bne wybani2
		rts

wybierak_fr_0
		dta b($42),b($81),b($42),b($42),b($24)
wybierak_fr_1
		dta b($24),b($42),b($24),b($24),b($24)

blink_percent_indicator
		ldx blink_cnt
		dex
		cpx #0
		bne blpein0

		ldx #blink_delay
		lda blink_clear
		and #%00000001
		cmp #1
		beq blpein1
		lda #126
		jmp blpein2
blpein1	lda #0
blpein2	sta screen+876+60+39
		sta screen+876+60+38
		cmp #0
		beq blpein3
		lda #127
blpein3	sta screen+876+60+30
		sta screen+876+60+31
		ldy blink_clear
		iny
		sty blink_clear		

blpein0 stx blink_cnt
		rts

wybierak_fr_2
		dta b($18),b($18),b($18),b($18),b($18)

vbi_routine
		jsr player+6
		jmp XITVBV

dli_routine
		pha
		txa
		pha
		tya
		pha

		lda VCOUNT

		ldx inmenu
		cpx #0
		beq dli_r3

		cmp #$2f
		bne dli_r4

		; Change color of title string
		ldx #col_main_title0
		ldy #col_szlaczek
		sta WSYNC
		sta WSYNC
		stx COLPF2
		sty COLPF0
		ldx #col_main_title1
		sta WSYNC
		sta WSYNC
		stx COLPF2
		ldx #col_main_title2
		sta WSYNC
		sta WSYNC
		stx COLPF2
		ldx #col_main_title3
		sta WSYNC
		sta WSYNC
		stx COLPF2
		ldx #col_main_title2
		sta WSYNC
		sta WSYNC
		stx COLPF2
		ldx #col_main_title1
		sta WSYNC
		sta WSYNC
		stx COLPF2
		ldx #col_main_title0
		sta WSYNC
		sta WSYNC
		stx COLPF2
		ldy bot_hscrol
		sty HSCROL
dli_XS	

dli_r4	
		cmp #$37
		bne dli_r3

		; Chabge color of the main text
		ldx #$00
		sta WSYNC
		stx COLPF2

dli_r3	
		cmp #$69
		bne dli_r0

		; Change bottom GR.0 color
		lda #col_footer2
		ldx #col_statustext
		sta WSYNC
		sta COLPF2
		stx COLPF1
		pla
		tay
		pla
		tax
		pla
		rti

dli_r0	cmp #$0f
		bne dli_r1

		; Change color for asses (pink) and make top of the "wybierak" yellow
		lda #col_asses1
		ldy #col_asses2
		ldx	#col_wybierak_head
		sta WSYNC
		sta COLPF2
		sty COLPF1
		stx COLPM0
		lda #col_obstacle
		sta COLPF3
		pla
		tay
		pla
		tax
		pla
		rti

dli_r1	cmp dli_excrem
		bne dli_r2

		; Change main body of the wybierak
		lda #col_excrements
		sta WSYNC
		sta COLPM0
		pla
		tay
		pla
		tax
		pla
		rti

dli_r2	cmp #$64
		bne dli_out

		; Change upper-bottom GR.0 color
		lda #col_footer1
		sta WSYNC
		sta COLPF2
		pla
		tay
		pla
		tax
		pla
		rti

dli_out	
		; DLI not handled yet? This must be the
		; indication of excrement level on the wybierak
		lda #col_wybierak_body
		sta WSYNC
		sta COLPM0

		pla
		tay
		pla
		tax
		pla
		rti

		org dl_game
		dta b(%01110000)			; top border
		dta b(%01110000)
		dta b(%11110000)			; DLI - asses color and wybierak head
		dta b(%01010111)			; 1xGR.2 = asses - first row
		dta a(screen)				; screen memory
		dta b(%00010111)			; 1xGR.2 = asses - middle row
		dta b(%00010111)			; 1xGR.2 = asses - bottom row
		dta b(%00010111)			; 1xGR.2 = excrement
		dta b(%00001011)			; Several $0b lines
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%10001011)			; DLI - excrements directly below wybierak head
		dta b(%00001011)
		dta b(%10001011)			; DLI - excrements end (must be in sync with shitco_init)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%10001011)			; DLI - upper footer color
		dta b(%00000010)			; single GR.0 line
		dta b(%10001011)			; DLI - bottom footer color
		dta b(%00000010)			; single GR.0 line
		dta b($41),a(dl_game)		; jvb

dl_menu
		dta b(%01110000)			; top border
		dta b(%01110000)
		dta b(%11110000)			; DLI - asses color and wybierak head
		dta b(%01010111)			; 1xGR.2 = asses - first row
		dta a(screen)				; screen memory
		dta b(%00010111)			; 1xGR.2 = asses - middle row
		dta b(%00010111)			; 1xGR.2 = asses - bottom row
		dta b(%10010111)			; 1xGR.2 = excrement - DLI - title color
		dta b(%10000111)			; 1xGR.2 = title - DLI - main text color
		dta b(%00000010)			; Several $02 lines
		dta b(%00000010)
		dta b(%00000010)
		dta b(%00000010)
		dta b(%00000010)
		dta b(%00000010)
		dta b(%00000010)
		dta b(%00000010)
		dta b(%00000010)
		dta b(%00000010)
		dta b(%00000010)
		dta b(%00000010)
		dta b(%10000110)			; 2xGR.1 = footer
		dta b(%00010110)
		dta b($41),a(dl_menu)		; jvb

dl_winner
		dta b(%01110000)			; top border
		dta b(%01110000)
		dta b(%11110000)			; DLI - asses color and wybierak head
		dta b(%01010111)			; 1xGR.2 = asses - first row
		dta a(screen)				; screen memory
		dta b(%00010111)			; 1xGR.2 = asses - middle row
		dta b(%00010111)			; 1xGR.2 = asses - bottom row
		dta b(%00010111)			; 1xGR.2 = excrement
		dta b(%00001011)			; Several $0b lines
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%10001011)			; DLI - excrements directly below wybierak head
		dta b(%00001011)
		dta b(%10001011)			; DLI - excrements end (must be in sync with shitco_init)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00000111)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00000111)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%00001011)
		dta b(%10001011)			; DLI - upper footer color
		dta b(%00000010)			; single GR.0 line
		dta b(%10001011)			; DLI - bottom footer color
		dta b(%00000010)			; single GR.0 line
		dta b($41),a(dl_game)		; jvb

		org music
		dta b($a0)
		dta b($e3)
		dta b($ed)
		dta b($e3)
		dta b($a0)
		dta b($e4)
		dta b($e1)
		dta b($f4)
		dta b($e1)
		dta b($a0)
		dta b($e6)
		dta b($e9)
		dta b($ec)
		dta b($e5)
		dta b($a0)
		dta b($8e)
		dta b($95)
		dta b($0d)
		dta b($20)
		dta b($06)
		dta b($9f)
		dta b($5d)
		dta b($e9)
		dta b($67)
		dta b($e1)
		dta b($13)
		dta b($53)
		dta b($5d)
		dta b($c0)
		dta b($ec)
		dta b($f6)
		dta b($18)
		dta b($79)
		dta b($ab)
		dta b($bf)
		dta b($f1)
		dta b($9e)
		dta b($42)
		dta b($e0)
		dta b($70)
		dta b($0d)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($1b)
		dta b($29)
		dta b($ff)
		dta b($ff)
		dta b($30)
		dta b($30)
		dta b($2f)
		dta b($31)
		dta b($30)
		dta b($31)
		dta b($31)
		dta b($31)
		dta b($31)
		dta b($31)
		dta b($31)
		dta b($32)
		dta b($32)
		dta b($32)
		dta b($32)
		dta b($32)
		dta b($33)
		dta b($33)
		dta b($33)
		dta b($33)
		dta b($34)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($30)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($f0)
		dta b($a1)
		dta b($cc)
		dta b($30)
		dta b($00)
		dta b($00)
		dta b($f0)
		dta b($c3)
		dta b($70)
		dta b($00)
		dta b($80)
		dta b($00)
		dta b($f0)
		dta b($a1)
		dta b($cc)
		dta b($30)
		dta b($00)
		dta b($00)
		dta b($f0)
		dta b($a5)
		dta b($00)
		dta b($30)
		dta b($00)
		dta b($00)
		dta b($0c)
		dta b($b5)
		dta b($03)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($f0)
		dta b($c3)
		dta b($70)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($f4)
		dta b($a6)
		dta b($00)
		dta b($50)
		dta b($00)
		dta b($00)
		dta b($f4)
		dta b($a1)
		dta b($00)
		dta b($20)
		dta b($00)
		dta b($00)
		dta b($f4)
		dta b($c7)
		dta b($70)
		dta b($20)
		dta b($00)
		dta b($00)
		dta b($fc)
		dta b($80)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($f8)
		dta b($a1)
		dta b($00)
		dta b($30)
		dta b($00)
		dta b($00)
		dta b($ff)
		dta b($80)
		dta b($00)
		dta b($00)
		dta b($82)
		dta b($40)
		dta b($04)
		dta b($a1)
		dta b($00)
		dta b($0a)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($9c)
		dta b($46)
		dta b($33)
		dta b($23)
		dta b($22)
		dta b($22)
		dta b($22)
		dta b($02)
		dta b($c8)
		dta b($79)
		dta b($33)
		dta b($12)
		dta b($01)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($9c)
		dta b($46)
		dta b($33)
		dta b($23)
		dta b($22)
		dta b($22)
		dta b($22)
		dta b($02)
		dta b($9c)
		dta b($46)
		dta b($33)
		dta b($23)
		dta b($22)
		dta b($22)
		dta b($22)
		dta b($02)
		dta b($9c)
		dta b($57)
		dta b($34)
		dta b($23)
		dta b($22)
		dta b($22)
		dta b($11)
		dta b($00)
		dta b($9c)
		dta b($47)
		dta b($23)
		dta b($11)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($33)
		dta b($33)
		dta b($33)
		dta b($33)
		dta b($33)
		dta b($33)
		dta b($33)
		dta b($03)
		dta b($32)
		dta b($64)
		dta b($98)
		dta b($88)
		dta b($77)
		dta b($67)
		dta b($66)
		dta b($05)
		dta b($cf)
		dta b($8a)
		dta b($56)
		dta b($34)
		dta b($33)
		dta b($33)
		dta b($33)
		dta b($03)
		dta b($29)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($9c)
		dta b($46)
		dta b($33)
		dta b($23)
		dta b($22)
		dta b($22)
		dta b($22)
		dta b($02)
		dta b($f7)
		dta b($8b)
		dta b($46)
		dta b($37)
		dta b($42)
		dta b($11)
		dta b($11)
		dta b($00)
		dta b($9c)
		dta b($67)
		dta b($55)
		dta b($55)
		dta b($55)
		dta b($55)
		dta b($55)
		dta b($05)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($00)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($04)
		dta b($05)
		dta b($03)
		dta b($03)
		dta b($03)
		dta b($03)
		dta b($df)
		dta b($06)
		dta b($07)
		dta b($05)
		dta b($05)
		dta b($03)
		dta b($03)
		dta b($ef)
		dta b($cf)
		dta b($ff)
		dta b($ff)
		dta b($df)
		dta b($0a)
		dta b($0b)
		dta b($ef)
		dta b($cf)
		dta b($ff)
		dta b($ff)
		dta b($df)
		dta b($10)
		dta b($10)
		dta b($10)
		dta b($10)
		dta b($10)
		dta b($10)
		dta b($ef)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($fe)
		dta b($ef)
		dta b($ff)
		dta b($00)
		dta b($02)
		dta b($02)
		dta b($02)
		dta b($02)
		dta b($02)
		dta b($02)
		dta b($02)
		dta b($06)
		dta b($ff)
		dta b($ff)
		dta b($02)
		dta b($02)
		dta b($02)
		dta b($02)
		dta b($ff)
		dta b($06)
		dta b($08)
		dta b($08)
		dta b($02)
		dta b($08)
		dta b($08)
		dta b($ff)
		dta b($05)
		dta b($0c)
		dta b($0d)
		dta b($06)
		dta b($0e)
		dta b($0e)
		dta b($0f)
		dta b($0f)
		dta b($0f)
		dta b($0f)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($00)
		dta b($01)
		dta b($3c)
		dta b($3c)
		dta b($3c)
		dta b($3c)
		dta b($3c)
		dta b($3c)
		dta b($3c)
		dta b($04)
		dta b($3c)
		dta b($3c)
		dta b($3c)
		dta b($3c)
		dta b($3c)
		dta b($3c)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($09)
		dta b($0a)
		dta b($09)
		dta b($09)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($0c)
		dta b($04)
		dta b($0f)
		dta b($0f)
		dta b($11)
		dta b($12)
		dta b($13)
		dta b($14)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($ff)
		dta b($02)
		dta b($49)
		dta b($81)
		dta b($49)
		dta b($81)
		dta b($49)
		dta b($81)
		dta b($49)
		dta b($81)
		dta b($47)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($49)
		dta b($81)
		dta b($49)
		dta b($81)
		dta b($49)
		dta b($81)
		dta b($49)
		dta b($81)
		dta b($47)
		dta b($80)
		dta b($44)
		dta b($80)
		dta b($49)
		dta b($81)
		dta b($49)
		dta b($81)
		dta b($49)
		dta b($81)
		dta b($49)
		dta b($81)
		dta b($47)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($49)
		dta b($81)
		dta b($49)
		dta b($81)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($81)
		dta b($ff)
		dta b($01)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($ff)
		dta b($01)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($49)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($4c)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($45)
		dta b($ff)
		dta b($00)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($4e)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($50)
		dta b($80)
		dta b($4e)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($50)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($53)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($50)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($4b)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($4e)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($45)
		dta b($80)
		dta b($45)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($45)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($45)
		dta b($80)
		dta b($4c)
		dta b($80)
		dta b($4b)
		dta b($80)
		dta b($ff)
		dta b($81)
		dta b($04)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($82)
		dta b($64)
		dta b($64)
		dta b($81)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($64)
		dta b($81)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($82)
		dta b($64)
		dta b($64)
		dta b($81)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($64)
		dta b($81)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($82)
		dta b($64)
		dta b($64)
		dta b($81)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($64)
		dta b($81)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($82)
		dta b($64)
		dta b($64)
		dta b($81)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($64)
		dta b($ff)
		dta b($03)
		dta b($49)
		dta b($50)
		dta b($80)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($49)
		dta b($4a)
		dta b($80)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($4a)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($49)
		dta b($50)
		dta b($80)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($49)
		dta b($4a)
		dta b($80)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($4a)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($49)
		dta b($50)
		dta b($80)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($49)
		dta b($4a)
		dta b($80)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($4a)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($49)
		dta b($50)
		dta b($80)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($47)
		dta b($47)
		dta b($80)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($81)
		dta b($ff)
		dta b($06)
		dta b($40)
		dta b($8e)
		dta b($41)
		dta b($8e)
		dta b($42)
		dta b($8e)
		dta b($43)
		dta b($8d)
		dta b($ff)
		dta b($06)
		dta b($44)
		dta b($8e)
		dta b($45)
		dta b($8e)
		dta b($46)
		dta b($8e)
		dta b($47)
		dta b($8d)
		dta b($ff)
		dta b($03)
		dta b($49)
		dta b($50)
		dta b($04)
		dta b($64)
		dta b($03)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($49)
		dta b($4a)
		dta b($04)
		dta b($64)
		dta b($03)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($4a)
		dta b($80)
		dta b($47)
		dta b($04)
		dta b($64)
		dta b($03)
		dta b($49)
		dta b($50)
		dta b($04)
		dta b($64)
		dta b($03)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($49)
		dta b($4a)
		dta b($04)
		dta b($64)
		dta b($03)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($4a)
		dta b($80)
		dta b($47)
		dta b($04)
		dta b($64)
		dta b($03)
		dta b($49)
		dta b($50)
		dta b($04)
		dta b($64)
		dta b($03)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($49)
		dta b($4a)
		dta b($04)
		dta b($64)
		dta b($03)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($4a)
		dta b($80)
		dta b($47)
		dta b($04)
		dta b($64)
		dta b($03)
		dta b($49)
		dta b($50)
		dta b($04)
		dta b($64)
		dta b($03)
		dta b($49)
		dta b($4c)
		dta b($80)
		dta b($47)
		dta b($47)
		dta b($04)
		dta b($64)
		dta b($03)
		dta b($49)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($04)
		dta b($64)
		dta b($64)
		dta b($ff)
		dta b($05)
		dta b($47)
		dta b($82)
		dta b($47)
		dta b($82)
		dta b($47)
		dta b($81)
		dta b($47)
		dta b($81)
		dta b($47)
		dta b($80)
		dta b($45)
		dta b($82)
		dta b($45)
		dta b($80)
		dta b($45)
		dta b($80)
		dta b($45)
		dta b($80)
		dta b($45)
		dta b($82)
		dta b($45)
		dta b($80)
		dta b($40)
		dta b($82)
		dta b($40)
		dta b($82)
		dta b($40)
		dta b($81)
		dta b($40)
		dta b($81)
		dta b($40)
		dta b($80)
		dta b($42)
		dta b($82)
		dta b($42)
		dta b($82)
		dta b($42)
		dta b($81)
		dta b($42)
		dta b($81)
		dta b($42)
		dta b($80)
		dta b($ff)
		dta b($07)
		dta b($47)
		dta b($8e)
		dta b($45)
		dta b($8e)
		dta b($40)
		dta b($8e)
		dta b($42)
		dta b($8d)
		dta b($ff)
		dta b($08)
		dta b($47)
		dta b($82)
		dta b($47)
		dta b($82)
		dta b($47)
		dta b($82)
		dta b($47)
		dta b($82)
		dta b($45)
		dta b($82)
		dta b($45)
		dta b($82)
		dta b($45)
		dta b($82)
		dta b($45)
		dta b($82)
		dta b($40)
		dta b($82)
		dta b($40)
		dta b($82)
		dta b($40)
		dta b($82)
		dta b($40)
		dta b($82)
		dta b($42)
		dta b($82)
		dta b($42)
		dta b($82)
		dta b($42)
		dta b($82)
		dta b($42)
		dta b($81)
		dta b($ff)
		dta b($08)
		dta b($47)
		dta b($80)
		dta b($09)
		dta b($6f)
		dta b($6f)
		dta b($08)
		dta b($47)
		dta b($80)
		dta b($09)
		dta b($6f)
		dta b($6f)
		dta b($08)
		dta b($47)
		dta b($80)
		dta b($09)
		dta b($6f)
		dta b($6f)
		dta b($08)
		dta b($47)
		dta b($80)
		dta b($09)
		dta b($6f)
		dta b($6f)
		dta b($08)
		dta b($45)
		dta b($80)
		dta b($09)
		dta b($6d)
		dta b($6d)
		dta b($08)
		dta b($45)
		dta b($80)
		dta b($09)
		dta b($6d)
		dta b($6d)
		dta b($08)
		dta b($45)
		dta b($80)
		dta b($09)
		dta b($6d)
		dta b($6d)
		dta b($08)
		dta b($45)
		dta b($80)
		dta b($09)
		dta b($6d)
		dta b($6d)
		dta b($08)
		dta b($40)
		dta b($80)
		dta b($09)
		dta b($6f)
		dta b($6f)
		dta b($08)
		dta b($40)
		dta b($80)
		dta b($09)
		dta b($6f)
		dta b($6f)
		dta b($08)
		dta b($40)
		dta b($80)
		dta b($09)
		dta b($6f)
		dta b($6f)
		dta b($08)
		dta b($40)
		dta b($80)
		dta b($09)
		dta b($6f)
		dta b($6f)
		dta b($08)
		dta b($42)
		dta b($80)
		dta b($09)
		dta b($6d)
		dta b($6d)
		dta b($08)
		dta b($42)
		dta b($80)
		dta b($09)
		dta b($6d)
		dta b($6d)
		dta b($08)
		dta b($42)
		dta b($80)
		dta b($09)
		dta b($6d)
		dta b($6d)
		dta b($08)
		dta b($42)
		dta b($80)
		dta b($09)
		dta b($6d)
		dta b($6d)
		dta b($ff)
		dta b($0a)
		dta b($58)
		dta b($82)
		dta b($5c)
		dta b($82)
		dta b($5f)
		dta b($82)
		dta b($5d)
		dta b($82)
		dta b($5a)
		dta b($80)
		dta b($5a)
		dta b($80)
		dta b($5c)
		dta b($80)
		dta b($5c)
		dta b($80)
		dta b($5f)
		dta b($80)
		dta b($5f)
		dta b($80)
		dta b($5d)
		dta b($82)
		dta b($5a)
		dta b($80)
		dta b($5a)
		dta b($80)
		dta b($61)
		dta b($80)
		dta b($61)
		dta b($80)
		dta b($61)
		dta b($80)
		dta b($5f)
		dta b($80)
		dta b($5f)
		dta b($82)
		dta b($58)
		dta b($82)
		dta b($61)
		dta b($80)
		dta b($61)
		dta b($80)
		dta b($61)
		dta b($80)
		dta b($5f)
		dta b($80)
		dta b($5f)
		dta b($81)
		dta b($ff)
		dta b($af)
		dta b($09)
		dta b($64)
		dta b($64)
		dta b($6b)
		dta b($64)
		dta b($64)
		dta b($64)
		dta b($6b)
		dta b($01)
		dta b($40)
		dta b($40)
		dta b($40)
		dta b($47)
		dta b($40)
		dta b($40)
		dta b($40)
		dta b($47)
		dta b($47)
		dta b($ff)
		dta b($02)
		dta b($40)
		dta b($82)
		dta b($44)
		dta b($82)
		dta b($47)
		dta b($82)
		dta b($45)
		dta b($82)
		dta b($42)
		dta b($80)
		dta b($42)
		dta b($80)
		dta b($44)
		dta b($80)
		dta b($44)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($45)
		dta b($82)
		dta b($42)
		dta b($80)
		dta b($42)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($47)
		dta b($82)
		dta b($40)
		dta b($82)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($49)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($47)
		dta b($81)
		dta b($ff)
		dta b($0b)
		dta b($64)
		dta b($80)
		dta b($09)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($80)
		dta b($6b)
		dta b($6b)
		dta b($0b)
		dta b($64)
		dta b($80)
		dta b($09)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($80)
		dta b($6b)
		dta b($6b)
		dta b($0b)
		dta b($6b)
		dta b($80)
		dta b($09)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($80)
		dta b($6b)
		dta b($6b)
		dta b($0b)
		dta b($6b)
		dta b($80)
		dta b($09)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($80)
		dta b($6b)
		dta b($6b)
		dta b($0b)
		dta b($64)
		dta b($80)
		dta b($09)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($80)
		dta b($6b)
		dta b($6b)
		dta b($0b)
		dta b($64)
		dta b($80)
		dta b($09)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($80)
		dta b($6b)
		dta b($6b)
		dta b($0b)
		dta b($6b)
		dta b($80)
		dta b($09)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($80)
		dta b($6b)
		dta b($6b)
		dta b($0b)
		dta b($6b)
		dta b($80)
		dta b($09)
		dta b($64)
		dta b($80)
		dta b($64)
		dta b($80)
		dta b($6b)
		dta b($6b)
		dta b($ff)
		dta b($0c)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($50)
		dta b($80)
		dta b($53)
		dta b($82)
		dta b($51)
		dta b($80)
		dta b($50)
		dta b($82)
		dta b($51)
		dta b($82)
		dta b($49)
		dta b($84)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($50)
		dta b($80)
		dta b($53)
		dta b($82)
		dta b($51)
		dta b($80)
		dta b($50)
		dta b($82)
		dta b($51)
		dta b($82)
		dta b($55)
		dta b($83)
		dta b($ff)
		dta b($0c)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($50)
		dta b($80)
		dta b($53)
		dta b($82)
		dta b($51)
		dta b($80)
		dta b($50)
		dta b($82)
		dta b($51)
		dta b($82)
		dta b($49)
		dta b($84)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($50)
		dta b($80)
		dta b($53)
		dta b($82)
		dta b($51)
		dta b($80)
		dta b($50)
		dta b($82)
		dta b($51)
		dta b($82)
		dta b($55)
		dta b($83)
		dta b($ff)
		dta b($05)
		dta b($40)
		dta b($40)
		dta b($47)
		dta b($47)
		dta b($40)
		dta b($40)
		dta b($49)
		dta b($49)
		dta b($40)
		dta b($40)
		dta b($47)
		dta b($47)
		dta b($40)
		dta b($40)
		dta b($49)
		dta b($49)
		dta b($40)
		dta b($40)
		dta b($47)
		dta b($47)
		dta b($40)
		dta b($40)
		dta b($49)
		dta b($49)
		dta b($40)
		dta b($40)
		dta b($47)
		dta b($47)
		dta b($40)
		dta b($40)
		dta b($49)
		dta b($49)
		dta b($40)
		dta b($40)
		dta b($44)
		dta b($44)
		dta b($40)
		dta b($40)
		dta b($47)
		dta b($47)
		dta b($40)
		dta b($40)
		dta b($44)
		dta b($44)
		dta b($40)
		dta b($40)
		dta b($47)
		dta b($47)
		dta b($40)
		dta b($40)
		dta b($44)
		dta b($44)
		dta b($40)
		dta b($40)
		dta b($47)
		dta b($47)
		dta b($40)
		dta b($40)
		dta b($44)
		dta b($44)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($47)
		dta b($ff)
		dta b($0c)
		dta b($55)
		dta b($80)
		dta b($55)
		dta b($80)
		dta b($55)
		dta b($80)
		dta b($55)
		dta b($80)
		dta b($55)
		dta b($80)
		dta b($53)
		dta b($80)
		dta b($56)
		dta b($82)
		dta b($55)
		dta b($80)
		dta b($53)
		dta b($82)
		dta b($55)
		dta b($82)
		dta b($53)
		dta b($84)
		dta b($53)
		dta b($80)
		dta b($53)
		dta b($80)
		dta b($53)
		dta b($80)
		dta b($53)
		dta b($80)
		dta b($53)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($55)
		dta b($88)
		dta b($02)
		dta b($44)
		dta b($80)
		dta b($47)
		dta b($80)
		dta b($45)
		dta b($83)
		dta b($ff)
		dta b($0c)
		dta b($55)
		dta b($80)
		dta b($55)
		dta b($80)
		dta b($55)
		dta b($80)
		dta b($55)
		dta b($80)
		dta b($55)
		dta b($80)
		dta b($53)
		dta b($80)
		dta b($56)
		dta b($80)
		dta b($55)
		dta b($82)
		dta b($53)
		dta b($82)
		dta b($55)
		dta b($82)
		dta b($53)
		dta b($84)
		dta b($53)
		dta b($80)
		dta b($53)
		dta b($80)
		dta b($53)
		dta b($80)
		dta b($53)
		dta b($80)
		dta b($53)
		dta b($80)
		dta b($51)
		dta b($80)
		dta b($55)
		dta b($91)
		dta b($ff)

		org player
		icl'cmc_player.asm'

		org $02e0
.dw		pstart

		end

